#include <gprolog.h>
#include <expat.h>

void callback()
{
  Pl_Query_Begin(PL_FALSE);
  Pl_Query_Call(Find_Atom("test"), 0, NULL);
  Pl_Query_End(PL_KEEP_FOR_PROLOG);
}

static void XMLCALL
start_element_handler(void *data, const char *el, const char **attr)
{
  callback();
}

PlBool
Pl_Expat_Error()
{
  XML_Parser p;
  p = XML_ParserCreate(NULL);
  XML_SetElementHandler(p, start_element_handler, NULL);
  callback();
  XML_Parse(p, "<a>", 3, 0);
}
